diff -r -u squid-2.6.STABLE13/src/forward.c new-STABLE13/src/forward.c
--- squid-2.6.STABLE13/src/forward.c	Tue Apr 17 18:35:17 2007
+++ new-STABLE13/src/forward.c	Sun May 13 00:59:37 2007
@@ -348,6 +348,15 @@
 	err->dnsserver_msg = xstrdup(dns_error_message);
 	fwdFail(fwdState, err);
 	comm_close(server_fd);
+    } else if (status == COMM_ERR_INV_ARGS) {
+	assert(fs);
+	err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, fwdState->request);
+	err->xerrno = errno;
+	fwdState->server_fd_was_inv_args = 1;
+	fwdFail(fwdState, err);
+	if (fs->peer)
+	    peerConnectFailed(fs->peer);
+	comm_close(server_fd);
     } else if (status != COMM_OK) {
 	assert(fs);
 	err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, fwdState->request);
@@ -387,23 +396,32 @@
 	/*
 	 * This marks the peer DOWN ... 
 	 */
-	if (fwdState->servers)
+	if (fwdState->servers) {
 	    if (fwdState->servers->peer)
 		peerConnectFailed(fwdState->servers->peer);
+	    if (fwdState->servers->code == HIER_DIRECT) {
+		struct sockaddr_storage host_addr;
+		safe_inet_addr(fwdState->request->hier.host, (struct sockaddr *)&host_addr);
+		ipcacheMarkBadAddr(fwdState->request->host, (struct sockaddr *)&host_addr);
+	    }
+	}
     }
     comm_close(fd);
 }
 
-static struct in_addr
+static struct sockaddr_storage *
 aclMapAddr(acl_address * head, aclCheck_t * ch)
 {
     acl_address *l;
-    struct in_addr addr;
+    struct sockaddr_storage *addr;
+    struct sockaddr_in *addr4;
     for (l = head; l; l = l->next) {
 	if (aclMatchAclList(l->acl_list, ch))
-	    return l->addr;
+	    return &l->addr;
     }
-    addr.s_addr = INADDR_ANY;
+    addr = xmalloc(sizeof(struct sockaddr_storage));
+    addr4 = (struct sockaddr_in *)addr;    
+    addr4->sin_addr.s_addr = INADDR_ANY;
     return addr;
 }
 
@@ -418,14 +436,14 @@
     return 0;
 }
 
-struct in_addr
+struct sockaddr_storage *
 getOutgoingAddr(request_t * request)
 {
     aclCheck_t ch;
     memset(&ch, '\0', sizeof(aclCheck_t));
     if (request) {
-	ch.src_addr = request->client_addr;
-	ch.my_addr = request->my_addr;
+	xmemcpy(&ch.src_addr, &request->client_addr, sizeof(struct sockaddr_storage));
+	xmemcpy(&ch.my_addr, &request->my_addr, sizeof(struct sockaddr_storage));
 	ch.my_port = request->my_port;
 	ch.request = request;
     }
@@ -439,7 +457,8 @@
     memset(&ch, '\0', sizeof(aclCheck_t));
     if (request) {
 	ch.src_addr = request->client_addr;
-	ch.my_addr = request->my_addr;
+	xmemcpy(&ch.src_addr, &request->client_addr, sizeof(struct sockaddr_storage));
+	xmemcpy(&ch.my_addr, &request->my_addr, sizeof(struct sockaddr_storage));
 	ch.my_port = request->my_port;
 	ch.request = request;
     }
@@ -456,11 +475,13 @@
     FwdServer *fs = fwdState->servers;
     const char *host;
     const char *name;
+    char portstr[8];
     unsigned short port;
     const char *domain = NULL;
     int ctimeout;
     int ftimeout = Config.Timeout.forward - (squid_curtime - fwdState->start);
-    struct in_addr outgoing;
+    struct sockaddr_storage outgoing, peerinfo;
+    struct addrinfo hints, *res;
     unsigned short tos;
 #if LINUX_TPROXY
     struct in_tproxy itp;
@@ -469,6 +490,9 @@
     assert(fs);
     assert(fwdState->server_fd == -1);
     debug(17, 3) ("fwdConnectStart: %s\n", url);
+    debug(17, 3) ("  fwdState: 0x%x was IPv6: %d tries: %d err: %d\n", 
+		fwdState, fwdState->server_fd_was_v6, fwdState->n_tries, 
+		fwdState->err ? fwdState->err->xerrno : 0);
     if (fs->peer) {
 	host = fs->peer->host;
 	name = fs->peer->name;
@@ -517,7 +541,7 @@
 	fd = pconnPop(name, port, domain, &fwdState->request->client_addr, 0);
 #endif
     if (fd == -1)
-	fd = pconnPop(name, port, domain, NULL, 0);
+	fd = pconnPop(name, port, domain, NULL);
     if (fd != -1) {
 	if (fwdCheckRetriable(fwdState)) {
 	    debug(17, 3) ("fwdConnectStart: reusing pconn FD %d\n", fd);
@@ -545,15 +569,44 @@
 #if URL_CHECKSUM_DEBUG
     assert(fwdState->entry->mem_obj->chksum == url_checksum(url));
 #endif
+
+    if (fwdState->server_fd_was_inv_args) {
+	fwdState->n_tries--;
+	if (!fs->peer)
+	    fwdState->origin_tries--;
+    }
+    else
+	fwdState->ia_cur = -1;
+    memset(&outgoing, 0, sizeof(outgoing));
+    if (fwdState->server_fd_was_v6) 
+	outgoing.ss_family = fwdState->server_fd_was_inv_args ? 
+				AF_INET : AF_INET6 ;
+    else 
+	outgoing.ss_family = fwdState->server_fd_was_inv_args ? 
+				AF_INET6 : AF_INET ;
+    fwdState->server_fd_was_inv_args = 0;
+
+    if (fs->peer && fs->peer->in_addr.ss_family == AF_INET6)
+	outgoing.ss_family = AF_INET6;
+    if (outgoing.ss_family == AF_INET6)
+	fwdState->server_fd_was_v6 = 1;
+    else
+	fwdState->server_fd_was_v6 = 0;
+#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
+    outgoing.ss_len = outgoing.ss_family == AF_INET6 ? 
+	sizeof(struct sockaddr_in6) : sizeof(struct sockaddr_in);
+#endif
+    tos = 0;
+/* HUSNI skip ACL
     outgoing = getOutgoingAddr(fwdState->request);
     tos = getOutgoingTOS(fwdState->request);
+*/
 
     debug(17, 3) ("fwdConnectStart: got addr %s, tos %d\n",
-	inet_ntoa(outgoing), tos);
+	sockaddr_ntoa(&outgoing), tos);
     fd = comm_openex(SOCK_STREAM,
 	IPPROTO_TCP,
-	outgoing,
-	0,
+	&outgoing,
 	COMM_NONBLOCKING,
 	tos,
 	url);
@@ -813,13 +866,13 @@
      * from peer_digest.c, asn.c, netdb.c, etc and should always
      * be allowed.  yuck, I know.
      */
-    if (r->client_addr.s_addr != no_addr.s_addr && r->protocol != PROTO_INTERNAL && r->protocol != PROTO_CACHEOBJ) {
+    if (((struct sockaddr_in *)&r->client_addr)->sin_addr.s_addr != no_addr.s_addr && r->protocol != PROTO_INTERNAL && r->protocol != PROTO_CACHEOBJ) {
 	/*      
 	 * Check if this host is allowed to fetch MISSES from us (miss_access)
 	 */
 	memset(&ch, '\0', sizeof(aclCheck_t));
-	ch.src_addr = r->client_addr;
-	ch.my_addr = r->my_addr;
+	xmemcpy(&ch.src_addr, &r->client_addr, sizeof(struct sockaddr_storage));
+	xmemcpy(&ch.my_addr, &r->my_addr, sizeof(struct sockaddr_storage));
 	ch.my_port = r->my_port;
 	ch.request = r;
 	answer = aclCheckFast(Config.accessList.miss, &ch);
@@ -871,9 +924,7 @@
 #if LINUX_TPROXY
     /* If we need to transparently proxy the request
      * then we need the client source address and port */
-    fwdState->src.sin_family = AF_INET;
-    fwdState->src.sin_addr = r->client_addr;
-    fwdState->src.sin_port = r->client_port;
+    xmemcpy(&fwdState->src, &r->client_addr, sizeof(struct sockaddr_storage));
 #endif
 
     storeLockObject(e);
@@ -947,6 +998,11 @@
 	err_type_str[errorState->type],
 	httpStatusString(errorState->http_status),
 	storeUrl(fwdState->entry));
+    if (fwdState->server_fd_was_inv_args) {
+	errorStateFree(errorState);
+	return;
+    }
+    fwdState->server_fd_was_inv_args = 0;
     if (fwdState->err)
 	errorStateFree(fwdState->err);
     fwdState->err = errorState;
diff -r -u squid-2.6.STABLE13/src/fqdncache.c new-STABLE13/src/fqdncache.c
--- squid-2.6.STABLE13/src/fqdncache.c	Tue May 30 09:56:11 2006
+++ new-STABLE13/src/fqdncache.c	Sun May 13 00:59:37 2007
@@ -351,11 +351,12 @@
 }
 
 void
-fqdncache_nbgethostbyaddr(struct in_addr addr, FQDNH * handler, void *handlerData)
+fqdncache_nbgethostbyaddr(struct sockaddr *addr, FQDNH * handler, void *handlerData)
 {
     fqdncache_entry *f = NULL;
-    char *name = inet_ntoa(addr);
+    char name[80]; 
     generic_cbdata *c;
+    getnameinfo(addr, SOCKLEN(addr), name, 80, NULL, 0, NULL);
     assert(handler);
     debug(35, 4) ("fqdncache_nbgethostbyaddr: Name '%s'.\n", name);
     FqdncacheStats.requests++;
@@ -427,11 +428,12 @@
 }
 
 const char *
-fqdncache_gethostbyaddr(struct in_addr addr, int flags)
+fqdncache_gethostbyaddr(struct sockaddr *addr, int flags)
 {
-    char *name = inet_ntoa(addr);
+    char name[80]; 
     fqdncache_entry *f = NULL;
     struct in_addr ip;
+    getnameinfo(addr, SOCKLEN(addr), name, 80, NULL, 0, NULL);
     assert(name);
     FqdncacheStats.requests++;
     f = fqdncache_get(name);
@@ -452,7 +454,7 @@
     }
     dns_error_message = NULL;
     /* check if it's already a FQDN address in text form. */
-    if (!safe_inet_addr(name, &ip))
+    if (!safe_inet_addr(name, &ip)) 
 	return name;
     FqdncacheStats.misses++;
     if (flags & FQDN_LOOKUP_IF_MISS)
@@ -506,13 +508,13 @@
 }
 
 const char *
-fqdnFromAddr(struct in_addr addr)
+fqdnFromAddr(struct sockaddr *addr)
 {
     const char *n;
-    static char buf[32];
+    static char buf[80];
     if (Config.onoff.log_fqdn && (n = fqdncache_gethostbyaddr(addr, 0)))
 	return n;
-    xstrncpy(buf, inet_ntoa(addr), 32);
+    xstrncpy(buf, sockaddr_ntoa(addr), 80);
     return buf;
 }
 
diff -r -u squid-2.6.STABLE13/src/ftp.c new-STABLE13/src/ftp.c
--- squid-2.6.STABLE13/src/ftp.c	Tue Mar 27 08:41:43 2007
+++ new-STABLE13/src/ftp.c	Sun May 13 00:59:37 2007
@@ -81,6 +81,8 @@
 };
 
 typedef struct _Ftpdata {
+    hash_link hash; /* dummy, must be fist */
+    int ia_cur;
     StoreEntry *entry;
     request_t *request;
     char user[MAX_URL];
@@ -1067,7 +1069,11 @@
 	strCat(ftpState->title_url, ftpState->user);
 	strCat(ftpState->title_url, "@");
     }
+    if (strchr(request->host, ':'))
+	strCat(ftpState->title_url, "[");
     strCat(ftpState->title_url, request->host);
+    if (strchr(request->host, ':'))
+	strCat(ftpState->title_url, "]");
     if (request->port != urlDefaultPort(PROTO_FTP)) {
 	strCat(ftpState->title_url, ":");
 	strCat(ftpState->title_url, xitoa(request->port));
@@ -1727,7 +1733,7 @@
 ftpSendPasv(FtpStateData * ftpState)
 {
     int fd;
-    struct sockaddr_in addr;
+    struct sockaddr_storage addr;
     socklen_t addr_len;
     if (ftpState->request->method == METHOD_HEAD && (ftpState->flags.isdir || ftpState->size != -1)) {
 	/* Terminate here for HEAD requests */
@@ -1760,10 +1766,14 @@
 	return;
     }
     /* Open data channel with the same local address as control channel */
+    if (addr.ss_family == AF_INET6)
+	((struct sockaddr_in6 *)&addr)->sin6_port = 0;
+    else
+	((struct sockaddr_in *)&addr)->sin_port = 0;
+
     fd = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	addr.sin_addr,
-	0,
+	&addr,
 	COMM_NONBLOCKING,
 	storeUrl(ftpState->entry));
     debug(9, 3) ("ftpSendPasv: Unconnected data socket created on FD %d\n", fd);
@@ -1782,7 +1792,10 @@
      * managed correctly and comm close handlers are cbdata fenced
      */
     ftpState->data.fd = fd;
-    snprintf(cbuf, 1024, "PASV\r\n");
+    if (addr.ss_family == AF_INET6)
+	snprintf(cbuf, 1024, "EPSV\r\n");
+    else
+	snprintf(cbuf, 1024, "PASV\r\n");
     ftpWriteCommand(cbuf, ftpState);
     ftpState->state = SENT_PASV;
     /*
@@ -1803,12 +1816,22 @@
     int fd = ftpState->data.fd;
     char *buf;
     LOCAL_ARRAY(char, ipaddr, 1024);
+    struct sockaddr_storage ipaddr_sock;
+    socklen_t addr_len;
     debug(9, 3) ("This is ftpReadPasv\n");
-    if (code != 227) {
+    addr_len = sizeof(ipaddr_sock);
+    if (getsockname(ftpState->ctrl.fd, (struct sockaddr *) &ipaddr_sock, &addr_len)) {
+	debug(9, 0) ("ftpSendPasv: getsockname(%d,..): %s\n",
+	    ftpState->ctrl.fd, xstrerror());
+	ftpFail(ftpState);
+	return;
+    }
+    if (code != 227 && code != 229) {
 	debug(9, 3) ("PASV not supported by remote end\n");
 	ftpSendPort(ftpState);
 	return;
     }
+    if (code == 227) {
     /*  227 Entering Passive Mode (h1,h2,h3,h4,p1,p2).  */
     /*  ANSI sez [^0-9] is undefined, it breaks on Watcom cc */
     debug(9, 5) ("scanning: %s\n", ftpState->ctrl.last_reply);
@@ -1820,12 +1843,24 @@
 	return;
     }
     snprintf(ipaddr, 1024, "%d.%d.%d.%d", h1, h2, h3, h4);
-    if (!safe_inet_addr(ipaddr, NULL)) {
+    port = ((p1 << 8) + p2);
+    memset(&ipaddr_sock, 0, sizeof(ipaddr_sock));
+    if (!safe_inet_addr(ipaddr, &ipaddr_sock)) {
 	debug(9, 1) ("Unsafe PASV reply from %s: %s\n", fd_table[ftpState->ctrl.fd].ipaddr, ftpState->ctrl.last_reply);
 	ftpSendPort(ftpState);
 	return;
     }
-    port = ((p1 << 8) + p2);
+    }
+    if (code == 229) {
+    debug(9, 5) ("scanning: %s\n", ftpState->ctrl.last_reply);
+    buf = ftpState->ctrl.last_reply + strcspn(ftpState->ctrl.last_reply, "(");
+    n = sscanf(buf, "(|||%d||)",&p1);
+    port = p1;
+    }
+    if (ipaddr_sock.ss_family == AF_INET)
+	((struct sockaddr_in *)&ipaddr_sock)->sin_port = htons(port);
+    if (ipaddr_sock.ss_family == AF_INET6)
+	((struct sockaddr_in6 *)&ipaddr_sock)->sin6_port = htons(port);
     if (0 == port) {
 	debug(9, 1) ("Unsafe PASV reply from %s: %s\n", fd_table[ftpState->ctrl.fd].ipaddr, ftpState->ctrl.last_reply);
 	ftpSendPort(ftpState);
@@ -1842,12 +1877,13 @@
     if (Config.Ftp.sanitycheck)
 	ftpState->data.host = xstrdup(fd_table[ftpState->ctrl.fd].ipaddr);
     else
-	ftpState->data.host = xstrdup(ipaddr);
+	ftpState->data.host = xstrdup(sockaddr_ntoa(&ipaddr_sock));
     safe_free(ftpState->ctrl.last_command);
     safe_free(ftpState->ctrl.last_reply);
     ftpState->ctrl.last_command = xstrdup("Connect to server data port");
+    ftpState->ia_cur = -1;
     debug(9, 5) ("ftpReadPasv: connecting to %s, port %d\n", ftpState->data.host, ftpState->data.port);
-    commConnectStart(fd, ipaddr, port, ftpPasvCallback, ftpState);
+    commConnectStart(fd, ftpState->data.host, port, ftpPasvCallback, ftpState);
 }
 
 static void
@@ -1870,7 +1906,7 @@
 ftpOpenListenSocket(FtpStateData * ftpState, int fallback)
 {
     int fd;
-    struct sockaddr_in addr;
+    struct sockaddr_storage addr;
     socklen_t addr_len;
     int on = 1;
     u_short port = 0;
@@ -1898,12 +1934,18 @@
      */
     if (fallback) {
 	setsockopt(ftpState->ctrl.fd, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on));
-	port = ntohs(addr.sin_port);
+	port = (addr.ss_family == AF_INET6) ?
+	ntohs(((struct sockaddr_in6 *)&addr)->sin6_port) : 
+	ntohs(((struct sockaddr_in *)&addr)->sin_port);
     }
+    else
+	if (addr.ss_family == AF_INET6)
+	    ((struct sockaddr_in6 *)&addr)->sin6_port = 0;
+	else
+	    ((struct sockaddr_in *)&addr)->sin_port = 0;
     fd = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	addr.sin_addr,
-	port,
+	&addr,
 	COMM_NONBLOCKING | (fallback ? COMM_REUSEADDR : 0),
 	storeUrl(ftpState->entry));
     debug(9, 3) ("ftpOpenListenSocket: Unconnected data socket created on FD %d\n", fd);
@@ -1925,7 +1967,7 @@
 ftpSendPort(FtpStateData * ftpState)
 {
     int fd;
-    struct sockaddr_in addr;
+    struct sockaddr_storage addr;
     socklen_t addr_len;
     unsigned char *addrptr;
     unsigned char *portptr;
@@ -1939,11 +1981,18 @@
 	ftpFail(ftpState);
 	return;
     }
-    addrptr = (unsigned char *) &addr.sin_addr.s_addr;
-    portptr = (unsigned char *) &addr.sin_port;
+    if (addr.ss_family == AF_INET) {
+    addrptr = (unsigned char *) &((struct sockaddr_in *)&addr)->sin_addr.s_addr;
+    portptr = (unsigned char *) &((struct sockaddr_in *)&addr)->sin_port;
     snprintf(cbuf, 1024, "PORT %d,%d,%d,%d,%d,%d\r\n",
 	addrptr[0], addrptr[1], addrptr[2], addrptr[3],
 	portptr[0], portptr[1]);
+    }
+    if (addr.ss_family == AF_INET6) {
+    snprintf(cbuf, 1024, "EPRT |2|%s|%u|\r\n",
+	sockaddr_ntoa(&addr), 
+	ntohs(((struct sockaddr_in6 *)&addr)->sin6_port));
+    }
     ftpWriteCommand(cbuf, ftpState);
     ftpState->state = SENT_PORT;
 }
@@ -1966,7 +2015,7 @@
 ftpAcceptDataConnection(int fd, void *data)
 {
     FtpStateData *ftpState = data;
-    struct sockaddr_in my_peer, me;
+    struct sockaddr_storage my_peer, me;
     debug(9, 3) ("ftpAcceptDataConnection\n");
 
     if (EBIT_TEST(ftpState->entry->flags, ENTRY_ABORTED)) {
@@ -1975,9 +2024,12 @@
     }
     fd = comm_accept(fd, &my_peer, &me);
     if (Config.Ftp.sanitycheck) {
-	char *ipaddr = inet_ntoa(my_peer.sin_addr);
-	if (strcmp(fd_table[ftpState->ctrl.fd].ipaddr, ipaddr) != 0) {
-	    debug(9, 1) ("FTP data connection from unexpected server (%s:%d), expecting %s\n", ipaddr, (int) ntohs(my_peer.sin_port), fd_table[ftpState->ctrl.fd].ipaddr);
+	if (strcmp(fd_table[ftpState->ctrl.fd].ipaddr, sockaddr_ntoa(&my_peer)) != 0) {
+	    debug(9, 1) ("FTP data connection from unexpected server (%s:%d), expecting %s\n", sockaddr_ntoa(&my_peer), (int)(
+		my_peer.ss_family == AF_INET6 ?
+			ntohs(((struct sockaddr_in6 *)&my_peer)->sin6_port) :
+			ntohs(((struct sockaddr_in *)&my_peer)->sin_port) ),
+		fd_table[ftpState->ctrl.fd].ipaddr);
 	    comm_close(fd);
 	    commSetSelect(ftpState->data.fd,
 		COMM_SELECT_READ,
@@ -1997,8 +2049,10 @@
     comm_close(ftpState->data.fd);
     debug(9, 3) ("ftpAcceptDataConnection: Connected data socket on FD %d\n", fd);
     ftpState->data.fd = fd;
-    ftpState->data.port = ntohs(my_peer.sin_port);
-    ftpState->data.host = xstrdup(inet_ntoa(my_peer.sin_addr));
+    ftpState->data.port = my_peer.ss_family == AF_INET6 ?
+	ntohs(((struct sockaddr_in6 *)&my_peer)->sin6_port) :
+	ntohs(((struct sockaddr_in *)&my_peer)->sin_port);
+    ftpState->data.host = xstrdup(sockaddr_ntoa(&my_peer));
     commSetTimeout(ftpState->ctrl.fd, -1, NULL, NULL);
     commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout,
 	ftpState);
diff -r -u squid-2.6.STABLE13/src/globals.h new-STABLE13/src/globals.h
--- squid-2.6.STABLE13/src/globals.h	Fri Jan 19 09:19:26 2007
+++ new-STABLE13/src/globals.h	Sun May 13 00:59:37 2007
@@ -97,6 +97,9 @@
 extern int theInIcpConnection;	/* -1 */
 extern int theOutIcpConnection;	/* -1 */
 extern int DnsSocket;		/* -1 */
+extern int theInIcpConnection6;	/* -1 */
+extern int theOutIcpConnection6;	/* -1 */
+extern int DnsSocket6;		/* -1 */
 #ifdef SQUID_SNMP
 extern int theInSnmpConnection;	/* -1 */
 extern int theOutSnmpConnection;	/* -1 */
@@ -108,7 +111,8 @@
 extern struct in_addr any_addr;
 extern struct in_addr local_addr;
 extern struct in_addr no_addr;
-extern struct in_addr theOutICPAddr;
+extern struct sockaddr_storage theOutICPAddr;
+extern struct sockaddr_storage theOutICPAddr6;
 extern struct in_addr theOutSNMPAddr;
 extern struct timeval current_time;
 extern struct timeval squid_start;
